(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('@angular/animations'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@flxng/code-show', ['exports', '@angular/core', '@angular/common/http', '@angular/animations', '@angular/common'], factory) :
    (global = global || self, factory((global.flxng = global.flxng || {}, global.flxng['code-show'] = {}), global.ng.core, global.ng.common.http, global.ng.animations, global.ng.common));
}(this, (function (exports, core, http, animations, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/code-show.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CodeShowService = /** @class */ (function () {
        function CodeShowService() {
        }
        CodeShowService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        CodeShowService.ctorParameters = function () { return []; };
        /** @nocollapse */ CodeShowService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function CodeShowService_Factory() { return new CodeShowService(); }, token: CodeShowService, providedIn: "root" });
        return CodeShowService;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/code-show.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var Language = {
        Html: "html",
        Typescript: "typescript",
    };
    var CodeShowComponent = /** @class */ (function () {
        function CodeShowComponent(_http, _elementRef, _changeDetectorRef) {
            this._http = _http;
            this._elementRef = _elementRef;
            this._changeDetectorRef = _changeDetectorRef;
            this.componentName = '';
            this.htmlCode = '';
            this.typescriptCode = '';
            this.expanded = false;
            this.fetchingCode = false;
            this.selectedLanguage = Language.Html;
            this.Language = Language;
        }
        /**
         * @return {?}
         */
        CodeShowComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () { };
        /**
         * @return {?}
         */
        CodeShowComponent.prototype.toggle = /**
         * @return {?}
         */
        function () {
            this.expanded = !this.expanded;
            if (this.expanded) {
                /** @type {?} */
                var codeForSelectedLanguage = this.selectedLanguage === Language.Html ? this.htmlCode : this.typescriptCode;
                if (!codeForSelectedLanguage) {
                    this.fetchCode();
                }
                else {
                    this._changeDetectorRef.detectChanges();
                    this.highlightCode();
                }
            }
        };
        /**
         * @param {?} language
         * @return {?}
         */
        CodeShowComponent.prototype.switchLanguage = /**
         * @param {?} language
         * @return {?}
         */
        function (language) {
            if (language === this.selectedLanguage) {
                return;
            }
            this.selectedLanguage = language;
            /** @type {?} */
            var codeForSelectedLanguage = this.selectedLanguage === Language.Html ? this.htmlCode : this.typescriptCode;
            if (!codeForSelectedLanguage) {
                this.fetchCode();
            }
            else {
                this._changeDetectorRef.detectChanges();
                this.highlightCode();
            }
        };
        /**
         * @return {?}
         */
        CodeShowComponent.prototype.highlightCode = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var codeElem = this._elementRef.nativeElement.querySelector("code.language-" + this.selectedLanguage);
            hljs.highlightBlock(codeElem);
        };
        /**
         * @return {?}
         */
        CodeShowComponent.prototype.fetchCode = /**
         * @return {?}
         */
        function () {
            return __awaiter(this, void 0, void 0, function () {
                var fileUrl, code, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.fetchingCode = true;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            fileUrl = "https://raw.githubusercontent.com/seidme/flxng/development/src/app/showcase-treetable/" + this.composeComponentPath();
                            return [4 /*yield*/, this._http.get(fileUrl, { responseType: 'text' }).toPromise()];
                        case 2:
                            code = _a.sent();
                            this.fetchingCode = false;
                            this.selectedLanguage === Language.Html ? (this.htmlCode = code) : (this.typescriptCode = code);
                            this._changeDetectorRef.detectChanges();
                            this.highlightCode();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            this.fetchingCode = false;
                            console.log('error: ', e_1);
                            return [3 /*break*/, 4];
                        case 4: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * @return {?}
         */
        CodeShowComponent.prototype.composeComponentPath = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var fileExtension = this.selectedLanguage === Language.Html ? 'html' : 'ts';
            /** @type {?} */
            var componentNameFragments = this.componentName.split('-');
            /** @type {?} */
            var componentExampleSuffix = componentNameFragments[componentNameFragments.length - 1];
            /** @type {?} */
            var mainComponentName = this.componentName.replace('-' + componentExampleSuffix, '');
            return mainComponentName + "/" + this.componentName + "/" + this.componentName + ".component." + fileExtension;
        };
        /**
         * @return {?}
         */
        CodeShowComponent.prototype.copyCode = /**
         * @return {?}
         */
        function () {
            // const codeElem = this._elementRef.nativeElement.querySelector(`code.language-${this.selectedLanguage}`);
            // codeElem.focus();
            // codeElem.select();
            // document.execCommand('copy');
            // const codeElem = this._elementRef.nativeElement.querySelector(`code.language-${this.selectedLanguage}`);
            // codeElem.focus();
            // codeElem.select();
            // document.execCommand('copy');
            // Page needs to be served over HTTPS in order the following to work!
            /** @type {?} */
            var codeForSelectedLanguage = this.selectedLanguage === Language.Html ? this.htmlCode : this.typescriptCode;
            navigator.clipboard.writeText(codeForSelectedLanguage).then((/**
             * @return {?}
             */
            function () { }), (/**
             * @param {?} e
             * @return {?}
             */
            function (e) {
                console.log(e);
                console.error('Works only if page is served over HTTPS!');
            }));
        };
        CodeShowComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'flx-code-show',
                        template: "<div class=\"container\"\r\n     [class.expanded]=\"expanded\">\r\n  <div class=\"opener\">\r\n    <button type=\"button\"\r\n            (click)=\"toggle()\">{{expanded ? 'Collapse' : 'View code'}}</button>\r\n  </div>\r\n\r\n  <div class=\"content\"\r\n       [@expansion]=\"'expansion'\"\r\n       *ngIf=\"expanded && (htmlCode || typescriptCode)\">\r\n    <div class=\"controls\">\r\n      <div class=\"languages\">\r\n        <button type=\"button\"\r\n                [class.selected]=\"selectedLanguage === Language.Html\"\r\n                (click)=\"switchLanguage(Language.Html)\">HTML</button>\r\n        &nbsp;\r\n        <button type=\"button\"\r\n                [class.selected]=\"selectedLanguage === Language.Typescript\"\r\n                (click)=\"switchLanguage(Language.Typescript)\"> TS </button>\r\n      </div>\r\n\r\n      <div>\r\n        <button type=\"button\"\r\n                (click)=\"copyCode()\"> Copy </button>\r\n      </div>\r\n    </div>\r\n\r\n    <pre\r\n         *ngIf=\"selectedLanguage === Language.Html && !fetchingCode\"><code class=\"language-{{selectedLanguage}}\">{{htmlCode}}</code></pre>\r\n    <pre\r\n         *ngIf=\"selectedLanguage === Language.Typescript && !fetchingCode\"><code class=\"language-{{selectedLanguage}}\">{{typescriptCode}}</code></pre>\r\n  </div>\r\n</div>",
                        animations: [
                            animations.trigger('expansion', [
                                animations.transition('void => expansion', [animations.style({ height: 0 }), animations.animate('120ms ease-out', animations.style({ height: '*' }))]),
                                animations.transition('expansion => void', [animations.style({ height: '*' }), animations.animate('120ms ease-out', animations.style({ height: '0' }))])
                            ])
                        ],
                        styles: [":host .container .opener{margin:1rem}:host .container .content{background:#e9ecf5;padding:.2rem;border-radius:.2rem}:host .container .content pre{margin:0}:host .container .content .controls{display:-webkit-box;display:flex;-webkit-box-pack:justify;justify-content:space-between;-webkit-box-align:center;align-items:center;margin:.2rem}:host .container .content .controls .languages{display:-webkit-box;display:flex;-webkit-box-pack:start;justify-content:flex-start;-webkit-box-align:center;align-items:center}:host .container .content .controls button{height:2rem;background:#fff}:host .container .content .controls button:hover{background:#e3e7f3}:host .container .content .controls button:active{background:#dae1f6}:host .container .content .controls button.selected{background:#e9ecf5}:host button{height:2.5rem;min-width:4rem;cursor:pointer;border:0;background:#e9ecf5;border-radius:.2rem;box-shadow:0 3px 4px 0 rgba(0,0,0,.14),0 2px 2px -2px rgba(0,0,0,.2),0 1px 2px 0 rgba(0,0,0,.12);color:#40337f;font-weight:700}:host button:hover{background:#e3e7f3}:host button:focus{outline:0}:host button.selected{background:#e3e8f8}:host button:active{background:#dae1f6}"]
                    }] }
        ];
        /** @nocollapse */
        CodeShowComponent.ctorParameters = function () { return [
            { type: http.HttpClient },
            { type: core.ElementRef },
            { type: core.ChangeDetectorRef }
        ]; };
        CodeShowComponent.propDecorators = {
            componentName: [{ type: core.Input }]
        };
        return CodeShowComponent;
    }());
    if (false) {
        /** @type {?} */
        CodeShowComponent.prototype.componentName;
        /** @type {?} */
        CodeShowComponent.prototype.htmlCode;
        /** @type {?} */
        CodeShowComponent.prototype.typescriptCode;
        /** @type {?} */
        CodeShowComponent.prototype.expanded;
        /** @type {?} */
        CodeShowComponent.prototype.fetchingCode;
        /** @type {?} */
        CodeShowComponent.prototype.selectedLanguage;
        /** @type {?} */
        CodeShowComponent.prototype.Language;
        /**
         * @type {?}
         * @private
         */
        CodeShowComponent.prototype._http;
        /**
         * @type {?}
         * @private
         */
        CodeShowComponent.prototype._elementRef;
        /**
         * @type {?}
         * @private
         */
        CodeShowComponent.prototype._changeDetectorRef;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/code-show.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CodeShowModule = /** @class */ (function () {
        function CodeShowModule() {
        }
        CodeShowModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [CodeShowComponent],
                        imports: [common.CommonModule],
                        exports: [CodeShowComponent]
                    },] }
        ];
        return CodeShowModule;
    }());

    exports.CodeShowComponent = CodeShowComponent;
    exports.CodeShowModule = CodeShowModule;
    exports.CodeShowService = CodeShowService;
    exports.Language = Language;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=flxng-code-show.umd.js.map
